/*  Lindley Systems Form Filler Program - Set parameters program
*/

#include <signal.h>
#include <stdlib.h>
#include <process.h>
#include <time.h>
#include <stdio.h>
#include <fcntl.h>
#include <sys\types.h>
#include <sys\stat.h>
#include <io.h>
#include <string.h>
#include "keycodes.h"
#include "z100keys.h"
#define  MAXATTR 4

#ifndef CLK_TCK
#define CLK_TCK 1000
#endif

/* Color attributes */
int    cur_attr;
int    nor_attr;
int    inv_attr;
int    normal_bg  = 0;
int    normal_fg  = 7;
int    inverse_bg = 7;
int    inverse_fg = 0;
int    colors[4];
int    ColRows[4] = {8,9,12,13};
int    now        = 0;
int    name_mode  = 1;
int    bgnd_mode  = 1;
int    get_mode   = 1;



#if Z100
    char Environment[]="ZFF.ENV";
    int  max[4]        = {7,7,7,7};
    char *colorname[8]=
        {"Black",      "Blue",           "Red",          "Magenta",
         "Green",      "Cyan",           "Yellow",       "White"};
#else
    char Environment[]="FF.ENV";
    int  max[4]        = {7,15,7,15};
    char *colorname[16]=
        {"Black",      "Blue",           "Green",        "Cyan",
         "Red",        "Magenta"  ,      "Brown",        "White",
         "Gray",       "Bright Blue",    "Bright Green", "Bright Cyan",
         "Bright Red", "Bright Magenta", "Yellow",       "Bright White"};
#endif

char blanks[] = {
"                                      \
                                       "};

/* ---------------------------- bailout ---------------------------- */
/*
 *      bailout -- optionally terminate upon interrupt
 */
int
bailout()
{
    char ch;

    signal(SIGINT, bailout);
    setcur(23,0);  /* Status line */
    wchar('\2');
    wstr(blanks,0);
    wstr("Terminate FFSET? (Y for yes, else continue) ",1);
    /* If off, turn console back on */
    if ((ch = getch()) == 'y' || ch == 'Y') exit(1);
    setcur(23,0);  /* Status line */
    wstr(blanks,0);
}
/* -------------------------show_colors-------------------------- */
void show_colors()
{
    setcur(15,14);
    wstr("\2                                                    ",1);
    setcur(16,14);
    wstr("   Ŀ   ",1);
    setcur(17,14);
    wstr("    This is normal text \1 This is inverse text \2    ",1);
    setcur(18,14);
    wstr("      ",1);
    setcur(19,14);
    wstr("                                                    ",1);
}
/* -------------------------show_selection----------------------- */
void show_selection(row,col,color)
{   int save;
    save=nor_attr;
    setcur(row,col);
    nor_attr=0; /* blank out area */
    wstr("\2                ",0);
    nor_attr=color;
    if (color == 0) nor_attr = 0x70;
    wstr("\2",0);
    wstr(colorname[color],1);
    nor_attr=save;
    wstr("\2",0);
}
/* ---------------------------- main ---------------------------- */

main (argc,argv)
int argc;
char *argv[];

{
int  arg, ix, x;
FILE *env_file;
char *bp, *cp, *dp, *endp, *xp, env_name[80], temp[80];
int c1, flag;
long tx;

    /* guarantee that needed DOS services are available */
    if (signal(SIGINT, bailout) == (int(*)())-1)
    {   perror("Can't set SIGINT");
        exit(2);
    }
    cur_attr = 0x07;
    nor_attr = 0x07;
    inv_attr = 0x70;
    init_keys();
    cls();
    setcur(5,0);
    wstr("\
                             Setup program for\r\n\
                            FORM FILL-R Program\r\n\
                               Version 2.11\r\n\
             Copyright 1988 Lindley Systems, all rights reserved.\r\n\
                            4257 Berwick Place\r\n\
                           Woodbridge, VA 22192\r\n\
                              (703)590-8890\r\n",1);

    setcur(23,0);
    wstr("Press any key to continue.",1);
    tx = clock() + 3*CLK_TCK;
    while (clock() < tx) if (kbhit()) {getch(); break;}
    cls();
    setcur(7,0);
    wstr("\
    Normal\r\n\
        background\r\n\
        foreground\r\n\n\
    Inverse\r\n\
        background\r\n\
        foreground",1);
    setcur(22,0);
    wstr("\
\1 F2 \2 Save settings and exit      \1 UP, DOWN \2 Select item to set",1);
    setcur(23,0);
    wstr("\
\1 ESC \2 Abandon settings and exit  \1 Space, BackSpace \2 Select color",1);
    /* Look for setup file in default directory first */
    getcwd (env_name,64);
    if (env_name[strlen(env_name) - 1] != '\\') strcat (env_name,"\\");
    strcat (env_name,Environment);
    env_file = fopen(env_name,"rb");
    if (env_file == NULL)
    if ((cp = getenv("PATH")) != NULL)
    /* Parse the path variable and look for the env_ file */
    {   endp = cp + strlen(cp) - 1;
        bp = cp;
        xp = cp;
        do
        {   /* Get next path component */
            dp = env_name;
            while (*xp == ';') ++xp;    /* skip leading ;'s */
            do
            {   *dp++ = *xp++;
            } while (xp <= endp && *xp != ';');
            if (*(dp-1) != '\\') *dp++ = '\\';
	    strcat (env_name,Environment);
            ++xp;
            env_file = fopen(env_name,"rb");
            if (xp >= endp) break;
        } while (env_file == NULL);
    }
    setcur(2,10);
    if (env_file != NULL)
    {   if (fgets(temp,80,env_file) != NULL)
            sscanf(temp,"%x",&nor_attr);
        if (fgets(temp,80,env_file) != NULL)
            sscanf(temp,"%x",&inv_attr);
        fclose (env_file);
	wstr("Upd",1);
    }
    else
    {
	getcwd (env_name,64);
	if (env_name[strlen(env_name) - 1] != '\\') strcat (env_name,"\\");
	strcat (env_name,Environment);
	wstr("Cre",1);
    }
    wstr("ating Environment file: ",1);
    wstr(env_name,0);
    cur_attr = nor_attr;
    colors[0] = nor_attr >> 4;
    colors[1] = nor_attr & 15;
    colors[2] = inv_attr >> 4;
    colors[3] = inv_attr & 15;

    for (now = 0; now < MAXATTR; ++now)
        show_selection(ColRows[now],19,colors[now]);
    now = 0;

/* Main program loop. */
/* Get input */
/* */

    do
    {   cur_attr = nor_attr;
        show_colors();

	setcur(ColRows[now],18);

        switch(c1=gtkey())
        {
/* F2 - Save settings */
        case F2:
	    env_file = fopen(env_name,"wb");
	    fprintf(env_file,"%x\r\n%x\r\n",nor_attr,inv_attr);
	    fclose(env_file);
            break;
/* ESC - Abandon settings */
        case ESC:
            break;
/* UP - Select item above or wrap to bottom */
        case UP:
            if(--now < 0) now = MAXATTR-1;
            show_selection(ColRows[now],19,colors[now]);
            break;
/* DOWN -  Select item below or wrap to top */
        case DOWN:
            if(++now > MAXATTR-1) now = 0;
            show_selection(ColRows[now],19,colors[now]);
            break;
/* Space - Select next color */
        case ' ':
            if (++colors[now] > max[now]) colors[now] = 0;
            show_selection(ColRows[now],19,colors[now]);
            break;
/* BS - Select previous color */
        case BS:
            if (--colors[now] < 0) colors[now] = max[now];
            show_selection(ColRows[now],19,colors[now]);
            break;
/*  Anything else */
        default: ;
        }
        nor_attr = (colors[0]<<4)+colors[1];
        inv_attr = (colors[2]<<4)+colors[3];
    } while (c1 != F2 && c1 != ESC);
    cur_attr = 0x07;
    cls();
    setcur(23,0);
    exit_keys();
    exit(0);
}
