/* newout - Part of Form Filler program

Used to open the print output file.

If initial FDF file, a print file will not be open.
   So, if temp2 is empty, use "PRN" as default.

If a command line print file is given, it is in temp2.

A print file name in a FDF file, other than the initial one,
  will be in temp2. 

After output file is opened, content of temp2 is deleted.
*/
#include "globals.h"

extern void give_error(char *text);
extern void display_status();
extern void draw_a_box(int y1, int x1, int y2, int x2, int dflag);
extern void strip_trailing(char *str);
extern void rem_ul(char *str);

/* in saveform.c: */
extern char Unable_To_Open[];

int newout()

{
int x, get_name;

    get_name = (strlen(temp2) < 1);

    if (prn_file_open)
    {   fclose(prn_file);
        prn_file_open = 0;
    }

    /* If file name is set in temp2, try to open. Then, ask for name */
    do
    {
      if (get_name)
      { pick_file_prompt("Enter New Output Name");
	display_status();
        stat_line = empty; /* Erase next status */
	draw_a_box(4,6,6,28+strlen(prn_name),1);
	setcur(5,8);
	wstr("Current Output is: ",1);
	wstr(prn_name,1);

	fkeydefn(21, 0, 2,Printer);
	wstr(" Device",1);
	fkeydefn(21,15,10,MainMenu);

	draw_a_box(10,10,12,43,2);
        get_mode=1;
        x=gedits(11,12,temp2,bgd,NULL);
	rem_ul(temp2);
	strip_trailing(temp2);

        if(x==F10 || x==EOF || x==ESC)
	  return(x);
	if(x==F2)
	  strcpy(temp2,Printer);	/* Default to PRN: */
      }
      prn_file = fopen(temp2,"ab");
      get_name = 1;     /* always get it 2nd time around */
      if (prn_file == NULL)
	give_error(Unable_To_Open);
    } while (prn_file == NULL);
    prn_file_open = 1;
    stat_line = empty;
    strcpy(prn_name,temp2);
    *temp2 = '\0';  /* Cancel this name */
    return(0);
}
